// test_print.cpp : Definiert den Einstiegspunkt fr die Konsolenanwendung.
//

#define WNT 1

#include "windows.h"

#include <AIS_InteractiveContext.hxx>
#include <AIS_Shape.hxx>
#include <BRepPrimAPI_MakeBox.hxx>
#include <Graphic3d_WNTGraphicDevice.hxx>
#include <V3d_View.hxx>
#include <V3d_Viewer.hxx>
#include <WNT_WClass.hxx>
#include <WNT_Window.hxx>
#include <Standard_ErrorHandler.hxx>

// PATH=%CASROOT%\win32\vc9\bind;W:\FTGL\win32_vcpp\Build;%PATH%

int main()
{
  Handle(Graphic3d_WNTGraphicDevice) GD = new Graphic3d_WNTGraphicDevice();
  Handle(WNT_WClass) aClass = new WNT_WClass("wnt_window", 0,
    CS_HREDRAW | CS_VREDRAW | CS_OWNDC);

  Handle(WNT_Window) w1 = new WNT_Window(GD, "window1", aClass,
    WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_CLIPSIBLINGS,
    50, 50, 150, 150, Quantity_NOC_BLACK);
  HWND hwnd1 = (HWND) w1->HWindow();
  ShowWindow(hwnd1, SW_SHOW);
  w1->Clear();

  Handle(WNT_Window) w2 = new WNT_Window(GD, "window2", aClass,
    WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_CLIPSIBLINGS,
    250, 50, 350, 150, Quantity_NOC_BLACK);
  HWND hwnd2 = (HWND) w2->HWindow();
  ShowWindow(hwnd2, SW_SHOW);
  w2->Clear();

  Handle(AIS_InteractiveContext) ais_context;
  Handle(V3d_Viewer) viewer;
  Handle(V3d_View) v1, v2;
  int counter = 0;
  try {
	  OCC_CATCH_SIGNALS
  do
  { if (!v1.IsNull())
    { v1->Remove();
      v2->Remove();
    }
    viewer = new V3d_Viewer(GD, (short*)"viewer");
    ais_context = new AIS_InteractiveContext(viewer);

    TopoDS_Shape box = BRepPrimAPI_MakeBox(100, 100, 100);
    Handle_AIS_Shape ais_shape = new AIS_Shape(box);
    ais_shape->SetColor(Quantity_NOC_BLUE1);
    ais_context->Display(ais_shape);

    v1 = viewer->CreateView();
    v1->SetWindow(w1);
    v1->FitAll();

	v1->Print(NULL, Standard_True, Standard_False, NULL);

    v2 = viewer->CreateView();
    v2->SetWindow(w2);
    v2->FitAll();
    
    std::cout << "Press any key";
    std::cin.get();
    ++counter;
  }
  while (counter < 2);
  } catch (...) {
	cout << "Exception ..." <<endl;
  }
  cout << "==>> Success" <<endl;
  return 0;
}

#pragma comment(lib, "TKShHealing.lib")
#pragma comment(lib, "TKBO.lib")
#pragma comment(lib, "TKStl.lib")
#pragma comment(lib, "FWOSPlugin.lib")
#pragma comment(lib, "PTKernel.lib")
#pragma comment(lib, "TKBool.lib")
#pragma comment(lib, "TKCAF.lib")
#pragma comment(lib, "TKCDF.lib")
#pragma comment(lib, "TKDraw.lib")
#pragma comment(lib, "TKernel.lib")
#pragma comment(lib, "TKFeat.lib")
#pragma comment(lib, "TKFillet.lib")
#pragma comment(lib, "TKGeomAlgo.lib")
#pragma comment(lib, "TKHLR.lib")
#pragma comment(lib, "TKMath.lib")
#pragma comment(lib, "TKOffset.lib")
#pragma comment(lib, "TKPCAF.lib")
#pragma comment(lib, "TKPrim.lib")
#pragma comment(lib, "TKPShape.lib")
#pragma comment(lib, "TKService.lib")
#pragma comment(lib, "TKTopAlgo.lib")
#pragma comment(lib, "TKV2d.lib")
#pragma comment(lib, "TKV3d.lib")
#pragma comment(lib, "TKBRep.lib")
#pragma comment(lib, "TKG2d.lib")
#pragma comment(lib, "TKG3d.lib")
#pragma comment(lib, "TKGeomBase.lib")
#pragma comment(lib, "TKXSBase.lib")
#pragma comment(lib, "TKIGES.lib")
#pragma comment(lib, "TKSTEP.lib")
#pragma comment(lib, "TKXCAF.lib")
#pragma comment(lib, "TKXDESTEP.lib")
#pragma comment(lib, "TKMesh.lib")
#pragma comment(lib, "TKAdvTools.lib")
#pragma comment(lib, "TKBin.lib")
#pragma comment(lib, "TKBinL.lib")
#pragma comment(lib, "TKBinTObj.lib")
#pragma comment(lib, "TKBinXCAF.lib")
#pragma comment(lib, "TKDCAF.lib")
#pragma comment(lib, "TKMeshVS.lib")
#pragma comment(lib, "TKNIS.lib")
#pragma comment(lib, "TKOpenGl.lib")
#pragma comment(lib, "TKPLCAF.lib")
#pragma comment(lib, "TKShapeSchema.lib")
#pragma comment(lib, "TKStdLSchema.lib")
#pragma comment(lib, "TKStdSchema.lib")
#pragma comment(lib, "TKSTEP209.lib")
#pragma comment(lib, "TKSTEPAttr.lib")
#pragma comment(lib, "TKSTEPBase.lib")
#pragma comment(lib, "TKSTL.lib")
#pragma comment(lib, "TKTObj.lib")
#pragma comment(lib, "TKTObjDRAW.lib")
#pragma comment(lib, "TKTopTest.lib")
#pragma comment(lib, "TKVRML.lib")
#pragma comment(lib, "TKXCAFSchema.lib")
#pragma comment(lib, "TKXDEDRAW.lib")
#pragma comment(lib, "TKXDEIGES.lib")
#pragma comment(lib, "TKXMesh.lib")
#pragma comment(lib, "TKXml.lib")
#pragma comment(lib, "TKXmlL.lib")
#pragma comment(lib, "TKXmlTObj.lib")
#pragma comment(lib, "TKXmlXCAF.lib")
#pragma comment(lib, "TKAdvTools.lib")
#pragma comment(lib, "TKBinL.lib")
#pragma comment(lib, "TKBinTObj.lib")
#pragma comment(lib, "TKBinXCAF.lib")
#pragma comment(lib, "TKLCAF.lib")
#pragma comment(lib, "TKMesh.lib")
#pragma comment(lib, "TKNIS.lib")
#pragma comment(lib, "TKPLCAF.lib")
#pragma comment(lib, "TKStdLSchema.lib")
#pragma comment(lib, "TKSTEP209.lib")
#pragma comment(lib, "TKSTEPAttr.lib")
#pragma comment(lib, "TKSTEPBase.lib")
#pragma comment(lib, "TKTObj.lib")
#pragma comment(lib, "TKTObjDraw.lib")
#pragma comment(lib, "TKXMesh.lib")
#pragma comment(lib, "TKXmlL.lib")
#pragma comment(lib, "TKXmlTObj.lib")